define(["dojo/_base/declare","dojo/_base/lang","dojo/_base/array","dojo/Deferred","dojo/query","dojo/on","dojo/when","dojo/dom-attr","dojo/dom-construct","dojo/dom-class","dojo/dom-style","dijit/form/Select","adaptiveimages/vendor/croppie/croppie.min","adaptiveimages/helpers/ContentHelper","adaptiveimages/AdaptiveImagesStore","adaptiveimages/ImageSizeCalculator","./Dialog","dojo/i18n!adaptiveimages/nls/Labels","dojo/text!./templates/CropDialog.html"],(function(i,t,o,e,n,s,r,a,h,l,d,p,c,g,m,u,_,f,P){return i([_],{innerTemplate:P,className:"adaptiveimages-dialog--crop",debugLogName:"CropDialog",imageId:null,provider:null,filename:null,model:null,validProportions:null,currentProportions:null,minimumSize:null,localized:f,_image:null,_calculator:null,_croppie:null,_cropPoints:null,_croppieInitialized:!1,_slider:null,_focalPointCueElement:null,_focalPointCueSize:16,_store:null,_originalImageSize:{native:{width:null,height:null},loaded:{width:null,height:null},scaled:null},_setConstraintsNotification:function(){var i;if(this.currentProportions.allowCropping&&(this.minimumSize&&(this.minimumSize.width>0&&this.minimumSize.height>0?i=f.dialogs.crop.constraintsDescription.size.replace("{width}",this.minimumSize.width||0).replace("{height}",this.minimumSize.height||0):this.minimumSize.width>0?i=f.dialogs.crop.constraintsDescription.width.replace("{width}",this.minimumSize.width||0):this.minimumSize.height>0&&(i=f.dialogs.crop.constraintsDescription.height.replace("{height}",this.minimumSize.height||0))),this.currentProportions&&this.currentProportions.x&&this.currentProportions.y&&(i=i||"",i+=` ${f.dialogs.crop.constraintsDescription.proportions.replace("{x}",this.currentProportions.x).replace("{y}",this.currentProportions.y)}`)),i)this.setNotification(i,"warning");else{let i=this.currentProportions.allowCropping?"noconstraints":this.currentProportions.allowFocalPoint?"focalPointOnly":"noSettings";this.setNotification(f.dialogs.crop.constraintsDescription[i],null)}},postMixInProperties:function(){this.inherited(arguments)},postCreate:function(){this.inherited(arguments),this.log("Creating crop dialog...",{imageId:this.imageId,model:this.model})},hide:function(){this._croppie&&this._croppie.destroy(),this.inherited(arguments)},constructor:function(){this.inherited(arguments),this._store=new m},startup:function(){this.inherited(arguments),this.showLoader(),this.addHelpContent(f.dialogs.crop.helpContent),this.own(s(document,"keypress",t.hitch(this,(function(i){if("+"===i.key||"-"===i.key){var t,o=parseFloat(this._slider.step),e=parseFloat(this._slider.value);switch(i.key){case"+":t=Math.min(e+o,this._slider.max);break;case"-":t=Math.max(e-2*o,this._slider.min)}if(!isNaN(t)){this.log(`Tuning crop zoom by ${o} to ${t}...`);try{this._croppie.setZoom(t)}catch{}}}})))),this._initialize()},_hasCroppingSet:function(){let i=this.validProportions.length;return"number"==typeof this.model.left&&"number"==typeof this.model.right&&"number"==typeof this.model.top&&"number"==typeof this.model.bottom&&(i||this.model.left+this.model.right+this.model.top+this.model.bottom>0)},_getPoints:function(){if(this._hasCroppingSet()){let i=[this.model.left*this._originalImageSize.loaded.width,this.model.top*this._originalImageSize.loaded.height,(1-this.model.right)*this._originalImageSize.loaded.width,(1-this.model.bottom)*this._originalImageSize.loaded.height];return this.log("Calculated absolute cropping points",{points:i}),i}return this.log("Skipping calculation of absolute cropping points as image has not been user-cropped",{model:this.model}),null},_getCurrentProportions:function(i){let t;this.log("Determining most closely matching proportions format based on current cropping...",{points:i});let e=o.filter(this.validProportions,(function(i){return!0===i.isDefault}))[0];if(this.model.wasCropped){const e=(i[2]-i[0])/(i[3]-i[1]);t=o.map(this.validProportions,(function(i){return i.diff=Math.abs(i.isFreeForm?e:e-Math.abs(i.x/i.y)),i})).sort(((i,t)=>i.diff>t.diff?0:i.diff<t.diff?-1:0))[0];const n=.1;t.diff<n?this.log("Initializing with proportions most closely matching current cropping",{cropRatio:e,current:t,all:this.validProportions}):(t=o.filter(this.validProportions,(function(i){return!0===i.isFreeForm}))[0],this.log("Cropping does not match any fixed proportions, assuming free-form cropping",t))}else t=e,this.log("Image is not cropped, loaded default proportions",t);return t||(this.logWarn("Unable to resolve current proportions"),e)},_validateCropArea:function(){if(!this.currentProportions.allowCropping)return this.log("Uncroppable proportions, resetting crop points"),this._setConstraintsNotification(),this.model.left=null,this.model.top=null,this.model.right=null,void(this.model.bottom=null);this.log("Validating crop area...");var i=Math.min(this._originalImageSize.loaded.width,parseInt(this._cropPoints[0])),t=Math.min(this._originalImageSize.loaded.height,parseInt(this._cropPoints[1])),o=Math.min(this._originalImageSize.loaded.width,parseInt(this._cropPoints[2])),e=Math.min(this._originalImageSize.loaded.height,parseInt(this._cropPoints[3])),n=!0,s=o-i,r=e-t;if(s>this._originalImageSize.loaded.width){const t=s-this._originalImageSize.loaded.width;this.log(`Cropped width exceeds image size due to rounding error, moving right coordinate ${t} pixels to the left`),i+=t}if(r>this._originalImageSize.loaded.height){const i=r-this._originalImageSize.loaded.height;this.log(`Cropped height exceeds image size due to rounding error, moving up the bottom coordinate by ${i} pixels`),e-=i}s=o-i,r=e-t,this.log(`Unadjusted crop set to ${s}x${r} px`,{points:this._cropPoints});var a,h=i/this._originalImageSize.loaded.width,l=t/this._originalImageSize.loaded.height,d=(this._originalImageSize.loaded.width-o)/this._originalImageSize.loaded.width,p=(this._originalImageSize.loaded.height-e)/this._originalImageSize.loaded.height;if(!this.currentProportions.isFreeForm){var c=t+(o-i)/(this.currentProportions.x/this.currentProportions.y),g=1-c/this._originalImageSize.loaded.height;if(p>=0)p>0?(this.log(`Calculated bottom coordinate of ${g} instead of editor specified ${p}`),p=g,e=c):this.log("Retaining zero as bottom coordinate");else{var m=i+(e-t)*(this.currentProportions.x/this.currentProportions.y),_=1-m/this._originalImageSize.loaded.width;this.log(`Calculated right coordinate of ${_} instead of editor specified ${d}`),d=_,o=m}let n=(s=o-i)/(r=e-t)-this.currentProportions.x/this.currentProportions.y;if(n>0){const i=s-r*(this.currentProportions.x/this.currentProportions.y);this.log(`Cropping ended up too wide, moving right coordinate ${i} pixels to the left`),d=1-(o-=i)/this._originalImageSize.loaded.width}else if(n<0){const i=r-s/(this.currentProportions.x/this.currentProportions.y);this.log(`Cropping ended up too narrow, moving up the bottom coordinate by ${i} pixels`),p=1-(e-=i)/this._originalImageSize.loaded.height}}s=Math.round((1-(h+d))*this._originalImageSize.native.width),r=Math.round((1-(l+p))*this._originalImageSize.native.height),this.titleNode.innerText=`${this.title} (${s}x${r})`;const P={image:this._image,minimumSize:this.minimumSize,proportions:this.currentProportions};if(this.log("Calculating image constraints...",P),this._calculator=new u(P),this.log("Calculated image constraints",this._calculator),s<this._calculator.minimumSize.width&&(a=f.dialogs.crop.notWideEnough.replace("{width}",this._calculator.minimumSize.width),this.logWarn(a),this.setNotification(a,"error"),n=!1),r<this._calculator.minimumSize.height&&(a=f.dialogs.crop.notTallEnough.replace("{height}",this._calculator.minimumSize.height),this.logWarn(a),this.setNotification(a,"error"),n=!1),!n)return this.setButtonsDisabledState(!0,0),void this.setStatusText(f.dialogs.crop.invalidCropSettings);this.setButtonsDisabledState(!1);var w=this._image.filename?this._image.filename:this._image.name,v=f.dialogs.crop.imageIdTooltip.replace("{provider}",this._image.provider),z=f.dialogs.crop.filenameTooltip.replace("{provider}",this._image.provider);if(this.imageId!=w){this.setStatusText(w,z);var S=`<a title='${v}' data-image-id="${this.imageId}" data-image-provider="${this._image.provider}" onclick="this.parentNode.title=''; this.parentNode.innerText=this.dataset.imageId; return false;" style="color: gray; font-size: 0.9em; margin-left: 5px; border-bottom: solid 1px gray;" href="#">${f.dialogs.crop.showIdLinkText}</a>`;this.statusText.innerHTML=`${this.statusText.innerHTML} ${S}`}else this.setStatusText(w,v);this._setConstraintsNotification(),this.model.left=Math.max(h,0),this.model.top=Math.max(l,0),this.model.right=Math.max(d,0),this.model.bottom=Math.max(p,0),this.log("Crop points set",this.model)},_clickedWithinViewPort:function(i){var t=this._croppie.elements.viewport.getBoundingClientRect(),o=i.clientX;if(o<t.left||o>=t.right)return!1;var e=i.clientY;return!(e<t.top||e>=t.bottom)&&{x:o-t.left,y:e-t.top}},_refreshFocalPointCuePosition:function(){if(this._focalPointCueElement){d.set(this._focalPointCueElement,{display:this.currentProportions.allowFocalPoint?"inherit":"none"});var i=parseInt(this._cropPoints[0]),t=parseInt(this._cropPoints[1]),o=(parseInt(this._cropPoints[2])-i)/this._croppie.options.viewport.width,e=null,n=null;null!=this.model.focalPointX&&null!=this.model.focalPointY&&(e=(this.model.focalPointX*this._originalImageSize.loaded.width-i)/o,n=(this.model.focalPointY*this._originalImageSize.loaded.height-t)/o,(e>this._croppie.options.viewport.width||e<0||n>this._croppie.options.viewport.height||n<0)&&(this.log("Focal point ended up outside crop area, reverting to default..."),e=n=null,this.model.focalPointX=null,this.model.focalPointY=null)),null!==e&&null!==n||(e=this._croppie.options.viewport.width/2,n=this._croppie.options.viewport.height/2),null===this.model.focalPointX||null===this.model.focalPointY?l.remove(this._focalPointCueElement,"adaptiveimages-dialog--crop__focal-point--explicit"):(this.log("Image has an explicit focal point",{model:this.model}),l.add(this._focalPointCueElement,"adaptiveimages-dialog--crop__focal-point--explicit")),d.set(this._focalPointCueElement,{left:`${Math.max(0,Math.min(e-this._focalPointCueSize/2-2,this._croppie.options.viewport.width))}px`,top:`${Math.max(0,Math.min(n-this._focalPointCueSize/2-1,this._croppie.options.viewport.height))}px`})}},_addFocalPointVisualCue:function(){this._focalPointCueElement||(this._focalPointCueElement=h.create("div",{class:"adaptiveimages-dialog--crop__focal-point",style:{position:"relative",display:"block",width:`${this._focalPointCueSize}px`,height:`${this._focalPointCueSize}px`}})),this._focalPointCueElement.parentElement||h.place(this._focalPointCueElement,this._croppie.elements.viewport)},_onCropAreaDoubleClick:function(i){if(this.currentProportions.allowFocalPoint){var t=this._clickedWithinViewPort(i);if(t&&null!==t.x&&null!==t.y){var o=parseInt(this._cropPoints[0]),e=parseInt(this._cropPoints[1]),n=(parseInt(this._cropPoints[2])-o)/this._croppie.options.viewport.width;this.model.focalPointX=Math.min(o+t.x*n,this._originalImageSize.loaded.width)/this._originalImageSize.loaded.width,this.model.focalPointY=Math.min(e+t.y*n,this._originalImageSize.loaded.height)/this._originalImageSize.loaded.height,this._refreshFocalPointCuePosition()}}},_onCropAreaMouseMove:function(i){this.currentProportions.allowFocalPoint&&d.set(this._focalPointCueElement,{display:1===i.which?"none":"inherit"})},_setTitle:function(){this.currentProportions.allowCropping?this.titleNode.innerText=this.title:this.currentProportions.allowFocalPoint?this.titleNode.innerText=f.dialogs.crop.setFocalPoint:this.titleNode.innerText=f.dialogs.crop.preview},_setCssClasses:function(){o.forEach(["adaptiveimages-dialog--croppable","adaptiveimages-dialog--focal-point","adaptiveimages-dialog--no-settings"],function(i){l.remove(this.domNode,i)}.bind(this)),this.currentProportions.allowCropping?l.add(this.domNode,"adaptiveimages-dialog--croppable"):this.currentProportions.allowFocalPoint?l.add(this.domNode,"adaptiveimages-dialog--focal-point"):l.add(this.domNode,"adaptiveimages-dialog--no-settings")},_initializeFocalPoint:function(){this._croppie?(this._addFocalPointVisualCue(),this._refreshFocalPointCuePosition(),this.own(s(this._croppie.elements.boundary,"dblclick",this._onCropAreaDoubleClick.bind(this))),this.own(s(this._croppie.elements.boundary,"mousemove",this._onCropAreaMouseMove.bind(this)))):this.logWarn("Cannot add focal point cue until cropper has been initialized")},_calculateBoundaryAndViewPort:function(){var i={width:548,height:254},t=!this.currentProportions.isFreeForm&&this.currentProportions.allowCropping?this.currentProportions:this._hasCroppingSet()?{x:this._cropPoints[2]-this._cropPoints[0],y:this._cropPoints[3]-this._cropPoints[1]}:{x:this._originalImageSize.loaded.width,y:this._originalImageSize.loaded.height};this.log(`Crop viewport proportions set to ${t.x}:${t.y}`,{currentProportions:this.currentProportions,originalImageSize:this._originalImageSize,viewportProportions:t,isConstrained:!this.currentProportions.isFreeForm});var o=i.height-20;this.log(`Calculating viewport width by multiplying viewport height ${o} by ${t.x/t.y}`);var e=Math.round(o*t.x/t.y),n={width:e,height:o,type:"square"};return n.width>i.width-10&&(e=i.width-10,n.width=e,n.height=e*(t.y/t.x)),{boundary:i,viewport:n}},_initialize:function(){this._store.getSettings().then(function(i){this._store.getMetaData(this.provider,this.imageId).then(function(h){const d=i.ui.cropDialogMaxWidth>0?i.ui.cropDialogMaxWidth:null,m=d?Math.min(h.width,d):h.width;d&&this.log(`Crop dialog configured with a maximum image width of ${d} px, resulting in a render width of ${m} px for the current image`),this._store.getImageUrl(this.provider,this.imageId,h.filename,d,m>1920?25:50,!0).then(function(i){const m=function(i,t){this.log("Initializing cropper...",{cropOptions:i,propertyValue:this.model}),this._setTitle(),this._setCssClasses();var o=new e((function(i){}));this._croppie&&(this._croppie.destroy(),this._croppie=null,this.log("Removed old cropper instance...")),this._focalPointCueElement=null,i.minZoom=Math.max(i.viewport.width/this._originalImageSize.loaded.width,i.viewport.height/this._originalImageSize.loaded.height),this._croppie=new c(this.cropArea,i);var r={url:t};return this._cropPoints=this._getPoints(),this._hasCroppingSet()&&this._cropPoints&&4===this._cropPoints.length?(r.points=this._cropPoints,this.log("Restored crop settings",{points:r.points,namedCoordinates:{left:r.points[0],top:r.points[1],right:r.points[2],bottom:r.points[3]},originalImageSize:this._originalImageSize})):this.log("No previous crop settings to restore",{model:this.model,hasCropping:this._hasCroppingSet(),points:this._cropPoints}),this._croppie.bind(r).then(function(t){this.currentProportions.allowCropping&&(this._slider=n(".cr-slider",this.innerTemplateContainer)[0],a.set(this._slider,"min",i.minZoom),this.own(s(this._slider,"mouseenter",function(){l.remove(this.scrollWheelAnimation,"hidden")}.bind(this))),this.own(s(this._slider,"mouseleave",function(){l.add(this.scrollWheelAnimation,"hidden")}.bind(this)))),this._hasCroppingSet()||this._croppie.setZoom(0),this.log("Croppie initialized",{croppie:this._croppie,points:this._cropPoints}),this._croppieInitialized=!0,this._initializeFocalPoint(),this._validateCropArea(),o.resolve()}.bind(this)),o}.bind(this),u=function(e){this._image=h,this._originalImageSize.native.width=h.width,this._originalImageSize.native.height=h.height,e&&e.width&&e.height?(this._originalImageSize.loaded.width=e.width,this._originalImageSize.loaded.height=e.height):(this._originalImageSize.loaded.width=this._originalImageSize.native.width,this._originalImageSize.loaded.height=this._originalImageSize.native.height),this._originalImageSize.scaled=this._originalImageSize.loaded.width!=this._originalImageSize.native.width||this._originalImageSize.loaded.height!=this._originalImageSize.native.height,this._originalImageSize.scaled&&this.log(`Scaled image of ${this._originalImageSize.loaded.width}x${this._originalImageSize.loaded.height} loaded for cropping`,this._originalImageSize),this._cropPoints=this._getPoints(),this.currentProportions=this._getCurrentProportions(this._cropPoints),this._setConstraintsNotification(),this.own(s(this.cropArea,"update",function(i){this._cropPoints=i.detail.points,this._croppieInitialized&&(this._validateCropArea(),this._refreshFocalPointCuePosition())}.bind(this)));var{viewport:n,boundary:a}=this._calculateBoundaryAndViewPort();const l=Math.max(n.width/this._originalImageSize.loaded.width,n.height/this._originalImageSize.loaded.height),d=this._originalImageSize.scaled?this._originalImageSize.native.width/this._originalImageSize.loaded.width:1;this._originalImageSize.scaled&&this.log("Calculated max zoom based on native image size",{maxZoom:d});var c={boundary:a,viewport:n,enforceBoundary:!0,customClass:"adaptiveimages-dialog--crop__croppie",enableZoom:!0,minZoom:l,maxZoom:d,enableResize:this.currentProportions.isFreeForm&&this.currentProportions.allowCropping,mouseWheelZoom:!0,showZoomer:!0};r(m(c,i),function(){if(this.log("Setting cropper options...",{options:c,proportions:this.validProportions,currentProportions:this.currentProportions}),1===this.validProportions.length)return void this.hideLoader();const e=o.map(this.validProportions,function(i,t){return{label:i.name,value:t+1,selected:this.currentProportions.name==i.name}}.bind(this)),n=new p({name:"proportionsSelector",class:`${this.className}__proportionsSelect`,options:e}).placeAt(this.cropArea,"first");this.own(n.on("change",function(o){this.log("Switched proportions",{value:o,currentProportions:this.currentProportions}),this.showLoader();let e=this.validProportions[o-1];this.currentProportions=e,this.currentProportions.allowFocalPoint||(this.model.focalPointX=null,this.model.focalPointY=null),this.currentProportions.allowCropping||(this.model.left=null,this.model.right=null,this.model.top=null,this.model.bottom=null);const n=t.mixin({},c);var{boundary:s,viewport:a}=this._calculateBoundaryAndViewPort();n.boundary=s,n.viewport=a,n.enableResize=this.currentProportions.isFreeForm&&this.currentProportions.allowCropping,n.minZoom=Math.max(n.viewport.width/this._originalImageSize.loaded.width,n.viewport.width/this._originalImageSize.loaded.height),r(m(n,i),function(){this._croppie.setZoom(0),this.hideLoader()}.bind(this))}.bind(this))),this.hideLoader()}.bind(this))}.bind(this);this.log("Loading image to determine dimensions...",{metadataDimensions:{width:h.width,height:h.height},maxWidth:d}),g.getRemoteImageDimensions(i).then(function(i){u(i)}.bind(this))}.bind(this))}.bind(this))}.bind(this))}})}));